<html>
<head>
<title>OGRE: OgreResourceBackgroundQueue.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreResourceBackgroundQueue.h</h1><a href="OgreResourceBackgroundQueue_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ResourceBackgroundQueue_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ResourceBackgroundQueue_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreResource_8h.html">OgreResource.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#   include &lt;boost/thread/thread.hpp&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#   include &lt;boost/thread/condition.hpp&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a>00044 
<a name="l00046"></a><a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373">00046</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a>;
<a name="l00047"></a>00047     
<a name="l00081"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html">00081</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ResourceBackgroundQueue&gt;
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keyword">public</span>:
<a name="l00092"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">00092</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background...">Listener</a>
<a name="l00093"></a>00093         {
<a name="l00094"></a>00094         <span class="keyword">public</span>:
<a name="l00101"></a>00101             <span class="keyword">virtual</span> <span class="keywordtype">void</span> operationCompleted(<a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket) = 0;
<a name="l00110"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html#a827a7b0a76edaaf6ed2cd5c66a0f2ea">00110</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> operationCompletedInThread(<a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket) {}
<a name="l00112"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html#28509ef0c32ec32d3fa12a672ba90c2f">00112</a>             <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background...">Listener</a>() {}
<a name="l00113"></a>00113 
<a name="l00114"></a>00114         };
<a name="l00116"></a>00116         <a class="code" href="OgrePrerequisites_8h.html#2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(initMutex)
<a name="l00118"></a>00118         <a class="code" href="OgrePrerequisites_8h.html#792b8674a3579bf049e399dbfecf9f8b">OGRE_THREAD_SYNCHRONISER</a>(initSync);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     protected:
<a name="l00122"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745">00122</a>         enum <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745" title="Enumerates the type of requests.">RequestType</a>
<a name="l00123"></a>00123         {
<a name="l00124"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745e8ee38057ec65c7818091b1caca338ca">00124</a>             RT_INITIALISE_GROUP,
<a name="l00125"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7459a307a52ca7851def901b0140b727a3d">00125</a>             RT_INITIALISE_ALL_GROUPS,
<a name="l00126"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7456fc6a9ca84e7613ae861d7c432843cc9">00126</a>             RT_LOAD_GROUP,
<a name="l00127"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7457327f4cfe781534a62de7541b5f23e15">00127</a>             RT_LOAD_RESOURCE,
<a name="l00128"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b7459d78e28a478d97ad7e7d0bbb03699fb5">00128</a>             RT_UNLOAD_GROUP,
<a name="l00129"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745471ed9d09791d8524d9f9b838cd2da72">00129</a>             RT_UNLOAD_RESOURCE,
<a name="l00130"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b74526df4cc6f4b6772e4026c5d6a2749c3c">00130</a>             RT_SHUTDOWN
<a name="l00131"></a>00131         };
<a name="l00133"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html">00133</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html" title="Encapsulates a queued request for the background queue.">Request</a>
<a name="l00134"></a>00134         {
<a name="l00135"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#37687751934abc52628e37889d1e53ad">00135</a>             <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> ticketID;
<a name="l00136"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#718f6a7a5ecfaf3320cac961ba9017e6">00136</a>             <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#edf467d04f827459c96ba08cdf61b745" title="Enumerates the type of requests.">RequestType</a> type;
<a name="l00137"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#71fadcee8894055990384ba36f7535a6">00137</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> resourceName;
<a name="l00138"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#e49ecc343c07587405753c5a7ba3cb98">00138</a>             <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> resourceHandle;
<a name="l00139"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#1786799d040b8c30ef8f72de8dfff224">00139</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> resourceType;
<a name="l00140"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#1bd93d793e4c91bc17b543a1dda2dfef">00140</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> groupName;
<a name="l00141"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#05161e514f2eea6b2a5db9691244cefa">00141</a>             <span class="keywordtype">bool</span> isManual; 
<a name="l00142"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#f80ae4cc37771f219d39e7e769aff83c">00142</a>             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader;
<a name="l00143"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#49c4d120787ff237299147bb1ee6b7f5">00143</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>* loadParams;
<a name="l00144"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1Request.html#692b07a3043994b968c663a31f8d9e97">00144</a>             <a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background...">Listener</a>* listener;
<a name="l00145"></a>00145         };
<a name="l00146"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#fd755f08d1050f013d3a5bfadd1e886b">00146</a>         <span class="keyword">typedef</span> std::list&lt;Request&gt; RequestQueue;
<a name="l00147"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#7358e15601d9373f738f38f6aa7a6ad1">00147</a>         <span class="keyword">typedef</span> std::map&lt;BackgroundProcessTicket, Request*&gt; RequestTicketMap;
<a name="l00148"></a>00148         
<a name="l00150"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#c46af6540373ba361e25f6b633403fad">00150</a>         RequestQueue mRequestQueue;
<a name="l00151"></a>00151         
<a name="l00153"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#c7dcdc6e70a2376d9e23afafeac4e145">00153</a>         RequestTicketMap mRequestTicketMap;
<a name="l00154"></a>00154 
<a name="l00156"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#e669d2a7f93ff48abdc16b26c39ecb3b">00156</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mNextTicketID;
<a name="l00157"></a>00157 
<a name="l00159"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html">00159</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html" title="Struct that holds details of queued notifications.">QueuedNotification</a>
<a name="l00160"></a>00160         {
<a name="l00161"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html#5e7ed618f40dee4159dfc72e0a965ed3">00161</a>             <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html" title="Struct that holds details of queued notifications.">QueuedNotification</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>* r)
<a name="l00162"></a>00162                 : resource(r), opListener(0), ticket(0)
<a name="l00163"></a>00163             {}
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html#6cfa88ce9fa2c2e33596daf709d20ffa">00165</a>             <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html" title="Struct that holds details of queued notifications.">QueuedNotification</a>(<a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background...">Listener</a>* l, <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> t)
<a name="l00166"></a>00166                 : resource(0), opListener(l), ticket(t)  
<a name="l00167"></a>00167             {}
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             <span class="comment">// Type 1 - Resource::Listener kind</span>
<a name="l00170"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html#3ffcf341502424db04b090fe17590fe4">00170</a>             <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>* resource;
<a name="l00171"></a>00171             <span class="comment">// Type 2 - ResourceBackgroundQueue::Listener kind</span>
<a name="l00172"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html#e33feab92fe669832b03fbbb25b8b220">00172</a>             <a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background...">Listener</a>* opListener;
<a name="l00173"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1QueuedNotification.html#99bfe85e719f0b9ad54a61e51151e3fe">00173</a>             <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket;
<a name="l00174"></a>00174         };
<a name="l00175"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#5200e347199cb918e891d847e863feb9">00175</a>         <span class="keyword">typedef</span> std::list&lt;QueuedNotification&gt; NotificationQueue;
<a name="l00177"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#5d1138c63255c3f1c8afac581a698530">00177</a>         NotificationQueue mNotificationQueue;
<a name="l00179"></a>00179         <a class="code" href="OgrePrerequisites_8h.html#2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mNotificationQueueMutex)
<a name="l00180"></a>00180 
<a name="l00181"></a>00181         
<a name="l00182"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#b5b6cf0b300afba334961387909accd8">00182</a>         bool mStartThread;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00186"></a>00186 <span class="preprocessor">        boost::thread* mThread;</span>
<a name="l00188"></a>00188 <span class="preprocessor">        boost::condition mCondition;</span>
<a name="l00190"></a>00190 <span class="preprocessor">        static void threadFunc(void);</span>
<a name="l00192"></a>00192 <span class="preprocessor">        BackgroundProcessTicket addRequest(Request&amp; req);</span>
<a name="l00194"></a>00194 <span class="preprocessor">        bool mShuttingDown;</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00197"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#b6a8c0ae1544490569ef3788c5c6f08b">00197</a> <span class="preprocessor">        void* mThread;</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00199"></a>00199 <span class="preprocessor"></span>
<a name="l00201"></a>00201         <a class="code" href="OgrePrerequisites_8h.html#18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00202"></a>00202 
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keywordtype">void</span> queueFireBackgroundOperationComplete(<a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background...">Listener</a>* listener,
<a name="l00218"></a>00218             <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220     <span class="keyword">public</span>:
<a name="l00221"></a>00221         <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>();
<a name="l00222"></a>00222         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>();
<a name="l00223"></a>00223 
<a name="l00240"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#ec6aec8fe94ec6bf29e8e7dc30d83319">00240</a>         <span class="keywordtype">void</span> setStartBackgroundThread(<span class="keywordtype">bool</span> startThread) { mStartThread = startThread; }
<a name="l00241"></a>00241 
<a name="l00246"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#b7ac1af9d48ef0177778522c5cb97a59">00246</a>         <span class="keywordtype">bool</span> getStartBackgroundThread(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mStartThread; }
<a name="l00250"></a>00250         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialise(<span class="keywordtype">void</span>);
<a name="l00251"></a>00251         
<a name="l00255"></a>00255         <span class="keyword">virtual</span> <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00256"></a>00256 
<a name="l00265"></a>00265         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> initialiseResourceGroup(
<a name="l00266"></a>00266             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, Listener* listener = 0);
<a name="l00267"></a>00267 
<a name="l00276"></a>00276         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> initialiseAllResourceGroups( 
<a name="l00277"></a>00277             Listener* listener = 0);
<a name="l00286"></a>00286         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> loadResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00287"></a>00287             Listener* listener = 0);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00296"></a>00296         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> unload(
<a name="l00297"></a>00297             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00298"></a>00298             Listener* listener = 0);
<a name="l00299"></a>00299 
<a name="l00306"></a>00306         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> unload(
<a name="l00307"></a>00307             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle, 
<a name="l00308"></a>00308             Listener* listener = 0);
<a name="l00309"></a>00309 
<a name="l00316"></a>00316         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> unloadResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00317"></a>00317             Listener* listener = 0);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00335"></a>00335         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> load(
<a name="l00336"></a>00336             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00337"></a>00337             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00338"></a>00338             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, 
<a name="l00339"></a>00339             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a>* loadParams = 0, 
<a name="l00340"></a>00340             Listener* listener = 0);
<a name="l00354"></a>00354         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isProcessComplete(<a class="code" href="namespaceOgre.html#b2b14cbcb50e07bda644e2e610df8373" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket);
<a name="l00355"></a>00355 
<a name="l00370"></a>00370         <span class="keywordtype">bool</span> _doNextQueuedBackgroundProcess();
<a name="l00371"></a>00371 
<a name="l00387"></a>00387         <span class="keywordtype">void</span> _initThread();
<a name="l00388"></a>00388 
<a name="l00402"></a>00402         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _queueFireBackgroundLoadingComplete(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>* res);
<a name="l00403"></a>00403 
<a name="l00411"></a>00411         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _fireBackgroundLoadingComplete(<span class="keywordtype">void</span>);
<a name="l00412"></a>00412 
<a name="l00428"></a>00428         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00444"></a>00444         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00445"></a>00445         
<a name="l00446"></a>00446 
<a name="l00447"></a>00447     };
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 <span class="preprocessor">#endif</span>
<a name="l00453"></a>00453 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:55 2008
</p>
</body>
</html>
